


#include <cstdlib>

#include <iostream>
#include <string>
#include <vector>




class sstring : public std::string { 

public: 

  sstring( const char* s ) : std::string(s) { } 
  sstring( const std::string& s ) : std::string(s) { } 

  bool contains(const std::string& s) { return find(s)!=std::string::npos; }

  std::string chop(const std::string& s) { 
    size_t pos = find(s);
    if (pos==std::string::npos ) { 
      std::string front = *this;
      erase(0, length());
      return front;
    }
    std::string front = substr(0, pos);
    erase(0, pos+1);
    return front;
  }



};


std::string EXECUTABLE;

int usage(const std::string& s="", int i=-1) { 
  std::cerr << "Usage: " << EXECUTABLE << " [-s|-t] VERSION" << std::endl;
    if ( s.size() ) std::cerr << s << std::endl;
    return i;
}


int main(int argc, char** argv) { 
  
  EXECUTABLE = argv[0]; 

  if ( argc<3 ) return usage();

  bool svn = (std::string(argv[1])=="-s");

  if ( !svn ) if ( std::string(argv[1])!="-t" ) return usage( "incorrect format option", -1 );

  sstring version = argv[2];


  std::string spliton;

  if      ( version.contains("-") ) spliton = "-";
  else if ( version.contains(".") ) spliton = ".";
  else  return usage( "string contains no version separators", -1 );


  //  std::cout << version << std::endl;


  std::vector<int> tags;

  while ( version.size() ) { 
    tags.push_back( std::atoi(version.chop(spliton).c_str()) );
  }

  if ( tags.size()!=3 ) return usage( "incorrect tag count ", -1 );


  if ( std::string(argv[0])=="increment" ) tags[2]++;

  if ( svn ) { 
    
    for ( int i=0 ; i<3 ; i++ ) { 
      if      ( tags[i]>99 ) std::cout << "XX";
      else if ( tags[i]<10 ) std::cout << "0" << tags[i];
      else                   std::cout << tags[i];
      if ( i<2 ) std::cout << "-";
    }
    std::cout << std::endl;

  }
  else { 
    for ( int i=0 ; i<3 ; i++ ) { 
      if      ( tags[i]>99 ) std::cout << "XX";
      else                   std::cout << tags[i];
      if ( i<2 ) std::cout << ".";
    }
    std::cout << std::endl;
  }

  return 0;
}
